config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"

Rails.application.routes.draw do
  # Administrate
  constraints CanAccessAdmin do
    namespace :admin do
      root controller: "users", action: :index
      resources :users do
        post :impersonate, on: :member
      end
      get :stop_impersonating, to: :stop_impersonating, controller: "users"
      mount Flipper::UI.app(Flipper) => "/flipper", as: "flipper"
      mount Sidekiq::Web => "/sidekiq", as: "sidekiq"
      mount LetterOpenerWeb::Engine, at: "/letter_opener", as: "letters" if Rails.env.development?
    end
  end

  mount StripeEvent::Engine, at: "/stripe/webhook"

  devise_for :users,  path: "",
                      path_names: {
                        sign_in: "sign-in",
                        sign_out: "sign-out",
                        sign_up: "sign-up"
                      },
                      controllers: {
                        registrations: "users/registrations"
                      }

  unauthenticated :user do
    devise_scope :user do
      root to: "pages#features"
    end
  end

  # Signed out (marketing) pages
  get "pricing", to: "pages#pricing"
  get "about", to: "pages#about"
  get "cancelled", to: "pages#cancelled"

  # Signed in pages
  authenticated :user do
    root to: "dashboard#show", as: "dashboard"
    get "pro", to: "pages#pro"
  end

  # Avatars
  patch "avatars", to: "avatars#update"
  delete "avatar", to: "avatars#destroy"

  # Subscription stuff
  get "billing", to: "subscriptions#show"
  get "subscribe", to: "subscriptions#new"
  patch "subscriptions", to: "subscriptions#update"
end

app/controllers/admin/application_controller.rb
# frozen_string_literal: true

# All Administrate controllers inherit from this `Admin::ApplicationController`,
# making it the ideal place to put authentication logic or other
# before_filters.
#
# If you want to add pagination or other controller-level concerns,
# you're free to overwrite the RESTful controller actions.
module Admin
  class ApplicationController < Administrate::ApplicationController
    impersonates :user
    # Define a custom finder by overriding the `find_resource` method:
    # def find_resource(param)
    #   User.find_by!(slug: param)
    # end

    # Override this value to specify the number of elements to display at a time
    # on index pages. Defaults to 20.
    # def records_per_page
    #   params[:per_page] || 20
    # end
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

require "application_helper"

class ApplicationController < ActionController::Base
  include Pundit
  include ActionView::Helpers::DateHelper
  protect_from_forgery with: :exception
  impersonates :user
  before_action :configure_permitted_parameters, if: :devise_controller?
  before_action :check_access, if: :access_required?

  def after_sign_in_path_for(resource)
    if resource.on_trial?
      time_left = distance_of_time_in_words(Time.current, current_user.try(:trial_ends_at))
      flash[:notice] = "You have #{time_left} left in your trial!"
    end
    dashboard_path
  end

  protected
    def configure_permitted_parameters
      added_params = %i(first_name last_name avatar product_id)
      devise_parameter_sanitizer.permit :sign_up, keys: added_params
      devise_parameter_sanitizer.permit :account_update, keys: added_params
    end

    # Users are always allowed to manage their session, registration and subscription
    def access_required?
      user_signed_in? &&
        !current_user.sub_active_or_trialing? &&
        !devise_controller? &&
        controller_name != "subscriptions"
    end

    # Redirect users in bad standing to billing page
    def check_access
      redirect_to billing_path,
        flash: {
          error: "Your trial has ended or your subscription has been cancelled. Please update your card - access will be restored once payment succeeds."
        }
    end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  # Appends to body tag if content_for :no_turbolink present
  def turbolinks?
    if content_for(:no_turbolink)
      { data: { no_turbolink: true } }
    else
      { data: nil }
    end
  end

  # For Devise custom sign in form
  # helper_method :resource_name, :resource, :devise_mapping
  def resource_name
    :user
  end

  def resource
    @resource ||= User.new
  end

  def devise_mapping
    @devise_mapping ||= Devise.mappings[:user]
  end
end

app/views/admin/application/_flashes.html.erb
<%#
# Flash Partial
This partial renders flash messages on every page.
## Relevant Helpers:
- `flash`:
  Returns a hash,
  where the keys are the type of flash (alert, error, notice, etc)
  and the values are the message to be displayed.
%>

<% if flash.any? %>
  <div class="flashes">
    <% flash.each do |key, value| -%>
      <div class="flash flash-<%= key %>"><%= value.html_safe %></div>
    <% end -%>
  </div>
<% end %>

app/views/admin/application/_javascript.html.erb
<%#
# Javascript Partial
This partial imports the necessary javascript on each page.
By default, it includes the application JS,
but each page can define additional JS sources
by providing a `content_for(:javascript)` block.
%>

<% Administrate::Engine.javascripts.each do |js_path| %>
  <%= javascript_include_tag js_path %>
<% end %>

<%= yield :javascript %>

<% if Rails.env.test? %>
  <%= javascript_tag do %>
    $.fx.off = true;
    $.ajaxSetup({ async: false });
  <% end %>
<% end %>

app/views/admin/application/_navigation.html.erb
<%#
# Navigation
This partial is used to display the navigation in Administrate.
By default, the navigation contains navigation links
for all resources in the admin dashboard,
as defined by the routes in the `admin/` namespace
%>

<nav class="navigation" role="navigation">
  <%= link_to(t("administrate.navigation.back_to_app"), root_url, class: "button button--alt") if defined?(root_url) %>

  <% Administrate::Namespace.new(namespace).resources_with_index_route.each do |resource| %>
  <%= link_to(
      display_resource_name(resource),
      resource_index_route(resource),
      class: "navigation__link navigation__link--#{nav_link_state(resource)}"
    ) if valid_action?(:index, resource) && show_action?(:index, model_from_resource(resource)) %>
  <% end %>
  <%= link_to "Sidekiq", admin_sidekiq_path, class: "navigation__link navigation__link--sidekiq", target: :_blank %>
  <%= link_to "Features", admin_flipper_path, class: "navigation__link navigation__link--features", target: :_blank  %>
</nav>